Program wav2ogg;
{$APPTYPE CONSOLE}

Uses SysUtils, Windows;
{$I wav2ogg.inc}


Type
      TOGGS = Packed Record
                Sign: Array[0..3] Of Char;
                Vers: Byte;
                Flag: Byte;
                PEnd: Int64;   // 0 - single page
                SNum: Integer; // any?..
                PNum: Integer; // 0, 1, 2...
                CSum: Cardinal; // CRCCheck()
                TNum: Byte;
              End;

Function CRCCheck(Data: Pointer; Sz: Cardinal): Cardinal;
Var I: Cardinal;
Begin
  result:=0;
  If Data <> Nil Then
    For I:=0 To Sz-1 Do
      Begin
        result := (result ShL 8) Xor crc_lookup[((result ShR 24) And $FF) Xor Byte(Data^)];
        Inc(Cardinal(Data));
      End;
End;

Var
    Fl, F: File;
    SC, I: Integer;
       OG: TOGGS;
        P: Pointer;
        L: ULARGE_INTEGER;
        B: Byte;
        W: Word;
        Z: Array Of Byte;
        S: String;
Begin
  WriteLn('WAV2OGG v1.0');
  WriteLn('(c) CTPAX-X Team 2010');
  WriteLn('http://www.CTPAX-X.ru/');
  WriteLn;
  If ParamCount <> 1 Then
    Begin
      WriteLn('Usage: wav2ogg filename.wav');
      Exit;
    End;
  If ParamCount <> 1 Then Exit;
  AssignFile(Fl, ParamStr(1));
  FileMode:=0;
  Reset(Fl, 1);
  FileMode:=2;
  S:='1234';
  Seek(Fl, 12);
  Repeat
    BlockRead(Fl, S[1], 4, I);
    BlockRead(Fl, SC, 4, I);
    WriteLn(S + '/' + IntToStr(SC));
    If S = 'fmt ' Then
      Begin
        SC:=SC - 2;
        BlockRead(Fl, W, 2, I);
        If W <> $FFFF Then Break;
      End;
    If S = 'data' Then Break
    Else Seek(Fl, FilePos(Fl) + SC);
  Until EOF(Fl);
  If S <> 'data' Then
    Begin
      WriteLn('Error: "' + ParamStr(1) + '" - not a .OGG file or bad container.');
      CloseFile(Fl);
      Exit;
    End;

  AssignFile(F, ChangeFileExt(ParamStr(1), '.ogg'));
  ReWrite(F, 1);

  FillChar(OG, SizeOf(OG), 0);
  OG.Sign:='OggS';
  OG.SNum:=1; // any, don't care
  OG.Flag:=2;
  While Not EOF(Fl) Do
    Begin
      BlockRead(Fl, L, 8);

      SetLength(Z, 0);
      SC:=L.LowPart;
      Repeat
        B:=255;
        If SC > 255 Then SC:=SC - 255
        Else
          Begin
            B:=SC;
            SC:=0;
          End;
        SetLength(Z, Length(Z) + 1);
        Z[Length(Z) - 1]:=B;
      Until SC = 0;

      OG.PEnd:=L.HighPart;
      OG.CSum:=0;
      OG.TNum:=Length(Z);

      SC:=SizeOf(OG) + OG.TNum + L.LowPart;
      GetMem(P, SC);

      Inc(Cardinal(P), SizeOf(OG));

      Move(Z[0], P^, Length(Z));
      Inc(Cardinal(P), Length(Z));

      BlockRead(Fl, P^, L.LowPart);
      Dec(Cardinal(P), SizeOf(OG) + Length(Z));
      If OG.Flag <> 2 Then
        If EOF(Fl) Then OG.Flag:=4 Else OG.Flag:=0;
      Move(OG, P^, SizeOf(OG));

      OG.CSum:=CRCCheck(P, SC);
      Move(OG, P^, SizeOf(OG));
      BlockWrite(F, P^, SC);

      FreeMem(P, SC);
      OG.PNum:=OG.PNum + 1; // next page
      If OG.Flag = 2 Then OG.Flag:=0;
    End;

  CloseFile(F);
  CloseFile(Fl);
End.
